<?php

function pre_wap ($letexte) {
	$letexte = ereg_replace("<[^>]*>", "", $letexte);
	$letexte = ereg_replace("\n- *", "\n&gt;&nbsp;", $letexte);
	$letexte = ereg_replace("\[\[", " (", $letexte);
	$letexte = ereg_replace("\]\]", ")", $letexte);
	$letexte = ereg_replace("\"", "&quot;", $letexte);
	$letexte = strtr($letexte, "$", "$$");
	return $letexte;
}

function reverse_html_code($letexte) {
	$trans = @array_flip(@get_html_translation_table(HTML_ENTITIES));
	if ($trans) $letexte = strtr($letexte, $trans);
	return $letexte;
}

function nettoyer_wap ($letexte) {
	$letexte = reverse_html_code($letexte);
	$letexte = ereg_replace("& ", "&amp; ", $letexte);
	$letexte = ereg_replace("&&nbsp;", "&amp;&nbsp;", $letexte);
	$letexte = ereg_replace("&#8217;", "'", $letexte);
	$letexte = ereg_replace("&mdash;", "-", $letexte);
	$letexte = ereg_replace("<p class=\"spip\">", "<p>&nbsp;&nbsp;", $letexte); // indenter paragraphes
	//$letexte = ereg_replace("", "oe", $letexte);
	$letexte = ereg_replace("<h3 class=\"spip\">", "<p>&nbsp;</p><p align=\"center\"><b>", $letexte);
	$letexte = ereg_replace("</h3>", "</b></p><p align=\"center\">-----</p>", $letexte);
	$letexte = ereg_replace(" class=\"([^\"]*)\"", "", $letexte);
	$letexte = ereg_replace("<blockquote>", "", $letexte);
	$letexte = ereg_replace("</blockquote>", "", $letexte);

	return $letexte;	
}

function texte_wap ($letexte, $longueur = 1000) {
	$letexte = propre(pre_wap($letexte));

	$uri = $GLOBALS["REQUEST_URI"];
	
	if (strpos($uri,"?") > 0)	{
		$url = substr($uri, 0, strpos($uri,"?"));
		$query = substr($uri, strpos($uri,"?") + 1, strlen($uri));
	}
	else {
		$url = $uri;
	}
	$url = ereg_replace("^.*/", "", $url); // supprimer jusqu'au dernier slash
	

	
	if (ereg("debut_wap=([0-9]+)", $query, $debut_texte_wap)) {
		$debut = $debut_texte_wap[1];
		$query = ereg_replace("\&debut_wap=([0-9]*)", "", $query);
		//$ret = "<p>X $debut</p>";
	}
	if (!$debut) $debut = 0;
		
	if (ereg("</p>",$letexte)) {
		$parties = explode ("</p>", $letexte);
		$num_part = 0;
		
		for ($i = 0; $i < count($parties); $i++) {
			if (strlen($parties[$i]) > 0) $texte[$num_part] .= $parties[$i]."</p>";
			if (strlen($texte[$num_part]) > $longueur) {
				$num_part ++;	
			}
		}
	} else {
		$debut = 0;
		$texte[0] = "<p>".$letexte."</p>";
	}

	if ($debut > 0) {
		$prec = $debut - 1;
	}
	
	if ($num_part > 0) $nav = "<b>".($debut+1)."/".($num_part+1)."</b>";
	if ($debut > 0) {
		$prec = $debut - 1;
		$query_prec = $query."&amp;debut_wap=$prec";
		$url_prec = $url."?".$query_prec;
		$nav = "\n<a href=\"$url_prec\">&lt;&lt;&lt;</a>&nbsp;&nbsp;&nbsp;".$nav;
	}
	if ($debut < $num_part) {
		$suiv = $debut + 1;
		$query_suiv = $query."&amp;debut_wap=$suiv";
		$url_suiv = $url."?".$query_suiv;
		$nav = $nav."&nbsp;&nbsp;&nbsp;<a href=\"$url_suiv\">&gt;&gt;&gt;</a>";
	}

	if ($nav) $ret = "<p align=\"center\">".$nav."</p>".$ret;
	$ret .= nettoyer_wap($texte[$debut]);
	if ($nav) $ret = $ret."<p align=\"center\">".$nav."</p>";
	

	
	return $ret;
}

?>